
#include <stddef.h>
#include <sys/time.h>
#include <libaio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <libaio.h>
#include <time.h>
#include <stdio.h>
#include <errno.h>

int main (int argc, char *argv[])
{
	struct  io_event* events; //!< max number of events
	char *fname;
	int fd=0;
	int bufsize=4096; //  IO'ing one page at atime
	void* buf;
	struct iocb cb={0},*cbp=&cb;
	struct timespec timeout={1,0}; // wait for one second 

	if (argc<2) {
		printf("aioerro test  <device name>\n");
		return -1;
	}

	fname=argv[1];
	printf("\n\t\t\t\t  TDD ERROR: CHECKING ERROR RETURNS VALUES FOR AIO");
	printf("\n\t\t\t\t  Please note that aioerr creates a file of 4 Kbytes size");
	printf("\n\t\t\t\t  test use direct IO and Page sized buffers\n");

	// prepare spooler context 

	io_context_t ctx={0}; 
	
	int rc = io_setup(1,&ctx);
	if (0!=rc){
		printf("io_setup %s\n",strerror(rc));
		return rc;
	}

   
	events = (struct io_event*) malloc(sizeof(struct io_event));

	if (events==0x00){
		perror("malloc :");
		return -1;
	}

	printf("\n\n\n\t\t  Test1 . testing reads. prepare a read command for file\n");

    buf = valloc(bufsize);
	if (!buf){ 
		printf("valloc failed\n");
		return -1;
	}

	memset(buf,0x00,bufsize);

	fd = open(fname, O_RDONLY | O_LARGEFILE | O_DIRECT , S_IREAD );
	
	if (fd  < 0){
		perror("async_open()");
		return -1;
	}
	
	printf("sync read=%d\n",pread(fd,buf,bufsize, 1<<25));
	puts("\n\n\n\t\tpull out the disk so an error would be generated and then press ENTER");
	getchar();

	io_prep_pread(&cb,fd, buf ,bufsize ,1<<25);
	rc=io_submit(ctx,1,&cbp);
	if (rc<0) {
		printf("io_submit (%d)\n",rc);
		return rc;
	}

	int retries=40;
	struct timeval ts,te;
	gettimeofday(&ts,0);

	while(retries--)
	{		
		rc = io_getevents(ctx,1,1,events,&timeout);
		gettimeofday(&te,0);
	
		switch(rc)
		{
		  case EINVAL:
				printf("\nEINVAL returned");
			break;
	
		 case EFAULT:
				printf("\nEFAULT returned");
			break;
	
		 case ENOSYS:
				printf("\nENOSYS returned");
			break;
	
		default:
			
            printf("%d returned (%d,%d)\n",rc,events->res,events->res2);
			if (rc>0) {
				printf("IO returned after %ld ms number of bytes transfered %d \n",
					   (te.tv_usec - ts.tv_usec)/1000+1000*(te.tv_sec-ts.tv_sec),
					   events->res);
				break;
			}

		}
	
		printf("\ntimeout is= %ld ms",
			   (te.tv_usec - ts.tv_usec)/1000+1000*(te.tv_sec-ts.tv_sec) );
	}
	return(0);
}




